require ("__base__.prototypes.entity.demo-pipecovers")

data:extend({
    {
        type = "recipe-category",
        name = "doing-bad-stuff"
    },
    {
        type = "recipe",
        name = "suage-processing",
        category = "doing-bad-stuff",
        energy_required = 5,
        enabled = true,
        icon = "__base__/graphics/icons/fluid/light-oil-cracking.png",
        icon_size = 32,
        ingredients =
        {
            {type="fluid", name="sulfuric-acid", amount=100},
        },
        results=
        {
            {type="fluid", name="water", amount=10},
            {type="fluid", name="water", amount=20}
        },
        subgroup = "smelting-machine",
        crafting_machine_tint =
        {
          primary = {r = 0.875, g = 0.735, b = 0.000, a = 0.000}, -- #dfbb0000
          secondary = {r = 0.103, g = 0.940, b = 0.000, a = 0.000}, -- #1aef0000
          tertiary = {r = 0.564, g = 0.795, b = 0.000, a = 0.000}, -- #8fca0000
        }
    }
})

function wickedFurnace(name, energySourceConnections, inputConnections, outputConnections)
    data:extend({
        {
            type = "item",
            name = name,
            icon = "__base__/graphics/icons/electric-furnace.png",
            icon_size = 32,
            subgroup = "smelting-machine",
            order = "c[electric-furnace]",
            place_result = name,
            stack_size = 50
      },
      {
          type = "furnace",
          name = name,
          icon = "__base__/graphics/icons/electric-furnace.png",
          icon_size = 32,
          flags = {"placeable-neutral", "placeable-player", "player-creation"},
          minable = {mining_time = 0.2, result = name},
          max_health = 350,
          corpse = "medium-remnants",
          dying_explosion = "medium-explosion",
          resistances = {
            {type = "fire",percent = 80}
          },
          collision_box = {{-1.2, -1.2}, {1.2, 1.2}},
          selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
          module_specification = {
            module_slots = 2,
            module_info_icon_shift = {0, 0.8}
          },
          allowed_effects = {"consumption", "speed", "productivity", "pollution"},
          crafting_categories = {"doing-bad-stuff"},
          result_inventory_size = 1,
          crafting_speed = 2,
          energy_usage = "180kW",
          source_inventory_size = 1,
          energy_source = {
              type = "fluid",
              scale_fluid_usage = true,
              fluid_usage_per_tick = 1,
              fluid_box = {
                  production_type = "input",
                  pipe_covers = pipecoverspictures(),
                  base_area = 10,
                  base_level = -1,
                  pipe_connections = energySourceConnections
              },
              emissions_per_minute = 1
          },
          vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
          working_sound = {
            sound = {
              filename = "__base__/sound/electric-furnace.ogg",
              volume = 0.7
            },
            apparent_volume = 1.5
          },
          animation = {
            layers = {
              {
                filename = "__base__/graphics/entity/electric-furnace/electric-furnace-base.png",
                priority = "high",
                width = 129,
                height = 100,
                frame_count = 1,
                shift = {0.421875, 0},
                hr_version =
                {
                  filename = "__base__/graphics/entity/electric-furnace/hr-electric-furnace.png",
                  priority = "high",
                  width = 239,
                  height = 219,
                  frame_count = 1,
                  shift = util.by_pixel(0.75, 5.75),
                  scale = 0.5
                }
              },
              {
                filename = "__base__/graphics/entity/electric-furnace/electric-furnace-shadow.png",
                priority = "high",
                width = 129,
                height = 100,
                frame_count = 1,
                shift = {0.421875, 0},
                draw_as_shadow = true,
                hr_version =
                {
                  filename = "__base__/graphics/entity/electric-furnace/hr-electric-furnace-shadow.png",
                  priority = "high",
                  width = 227,
                  height = 171,
                  frame_count = 1,
                  draw_as_shadow = true,
                  shift = util.by_pixel(11.25, 7.75),
                  scale = 0.5
                }
              }
            }
          },
          working_visualisations =
          {
            {
              animation =
              {
                filename = "__base__/graphics/entity/electric-furnace/electric-furnace-heater.png",
                priority = "high",
                width = 25,
                height = 15,
                frame_count = 12,
                animation_speed = 0.5,
                shift = {0.015625, 0.890625},
                hr_version =
                {
                  filename = "__base__/graphics/entity/electric-furnace/hr-electric-furnace-heater.png",
                  priority = "high",
                  width = 60,
                  height = 56,
                  frame_count = 12,
                  animation_speed = 0.5,
                  shift = util.by_pixel(1.75, 32.75),
                  scale = 0.5
                }
              },
              light = {intensity = 0.4, size = 6, shift = {0.0, 1.0}, color = {r = 1.0, g = 1.0, b = 1.0}}
            },
            {
              animation =
              {
                filename = "__base__/graphics/entity/electric-furnace/electric-furnace-propeller-1.png",
                priority = "high",
                width = 19,
                height = 13,
                frame_count = 4,
                animation_speed = 0.5,
                shift = {-0.671875, -0.640625},
                hr_version =
                {
                  filename = "__base__/graphics/entity/electric-furnace/hr-electric-furnace-propeller-1.png",
                  priority = "high",
                  width = 37,
                  height = 25,
                  frame_count = 4,
                  animation_speed = 0.5,
                  shift = util.by_pixel(-20.5, -18.5),
                  scale = 0.5
                }
              }
            },
            {
              animation =
              {
                filename = "__base__/graphics/entity/electric-furnace/electric-furnace-propeller-2.png",
                priority = "high",
                width = 12,
                height = 9,
                frame_count = 4,
                animation_speed = 0.5,
                shift = {0.0625, -1.234375},
                hr_version =
                {
                  filename = "__base__/graphics/entity/electric-furnace/hr-electric-furnace-propeller-2.png",
                  priority = "high",
                  width = 23,
                  height = 15,
                  frame_count = 4,
                  animation_speed = 0.5,
                  shift = util.by_pixel(3.5, -38),
                  scale = 0.5
                }
              }
            }
          },
          fast_replaceable_group = "assembling-machine",
  
          fluid_boxes =
          {
            {
              production_type = "input",
              pipe_covers = pipecoverspictures(),
              base_area = 10,
              base_level = -1,
              pipe_connections = inputConnections
            },
            {
              production_type = "output",
              pipe_covers = pipecoverspictures(),
              base_level = 1,
              pipe_connections = outputConnections
            }
          }
      }
      })
end

-- lower left underground
LL = {
    { type="input-output", position = {-2, 1}, max_underground_distance = 10 }
}
-- lower right underground
LR = {
    { type="input-output", position = {2, 1}, max_underground_distance = 10 }
}
-- upper group
UG = {
    { type="input-output", position = {-1, -2} },
    { type="input-output", position = {2, -1}, max_underground_distance = 10 }
}
-- reverse order upper group
rUG = {
    { type="input-output", position = {2, -1}, max_underground_distance = 10 },
    { type="input-output", position = {-1, -2} }
}

wickedFurnace("boskid-furnace-a",  LL,  LR,  UG)
wickedFurnace("boskid-furnace-b",  LL,  LR, rUG)
wickedFurnace("boskid-furnace-c",  LL,  UG,  LR)
wickedFurnace("boskid-furnace-d",  LL, rUG,  LR)
wickedFurnace("boskid-furnace-e",  LR,  LL,  UG)
wickedFurnace("boskid-furnace-f",  LR,  LL, rUG)
wickedFurnace("boskid-furnace-g",  LR,  UG,  LL)
wickedFurnace("boskid-furnace-h",  LR, rUG,  LL)
wickedFurnace("boskid-furnace-i",  UG,  LR,  LL)
wickedFurnace("boskid-furnace-j", rUG,  LR,  LL)
wickedFurnace("boskid-furnace-k",  UG,  LL,  LR)
wickedFurnace("boskid-furnace-l", rUG,  LL,  LR)

-- Setup for other tests
UG = {
    { type="input-output", position = {-2, -1}, max_underground_distance = 10 },
    { type="input-output", position = {2, -1}, max_underground_distance = 10 }
}
LL = {
    { type="input-output", position = {-2, 1}, max_underground_distance = 10 },
    { type="input-output", position = {-1, 2} }
}
LR = {
    { type="input-output", position = {2, 1}, max_underground_distance = 10 },
    { type="input-output", position = {1, 2} }
}

wickedFurnace("boskid-furnace-1",  LL,  LR,  UG)
wickedFurnace("boskid-furnace-2",  LL,  UG,  LR)
wickedFurnace("boskid-furnace-3",  LR,  UG,  LL)
wickedFurnace("boskid-furnace-4",  LR,  LL,  UG)
wickedFurnace("boskid-furnace-5",  UG,  LL,  LR)
wickedFurnace("boskid-furnace-6",  UG,  LR,  LL)


-- 1.0.5: boiler - fluid locked underground connectors - since fluid mixing fix may remove building, what if that building happend to be underground connector that will now connect to another incompatible FS?

data:extend({
{
    type = "item",
    name = "boskid-boiler-1",
    icon = "__base__/graphics/icons/boiler.png",
    icon_size = 32,
    subgroup = "energy",
    order = "b[steam-power]-a[boiler]",
    place_result = "boskid-boiler-1",
    stack_size = 50
},
{
    type = "boiler",
    name = "boskid-boiler-1",
    icon = "__base__/graphics/icons/boiler.png",
    icon_size = 32,
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 0.2, result = "boskid-boiler-1"},
    max_health = 200,
    corpse = "boiler-remnants",
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    mode = "output-to-separate-pipe",
    resistances =
    {
      {
        type = "fire",
        percent = 90
      },
      {
        type = "explosion",
        percent = 30
      },
      {
        type = "impact",
        percent = 30
      }
    },
    collision_box = {{-1.29, -0.79}, {1.29, 0.79}},
    selection_box = {{-1.5, -1}, {1.5, 1}},
    target_temperature = 165,
    fluid_box =
    {
      base_area = 1,
      height = 2,
      base_level = -1,
      pipe_covers = pipecoverspictures(),
      pipe_connections =
      {
        {type = "input-output", position = {-2, 0.5}, max_underground_distance = 10},
        {type = "input-output", position = {2, 0.5}, max_underground_distance = 10}
      },
      production_type = "input-output",
      filter = "water"
    },
    output_fluid_box =
    {
      base_area = 1,
      height = 2,
      base_level = 1,
      pipe_covers = pipecoverspictures(),
      pipe_connections =
      {
        {type = "output", position = {0, -1.5}, max_underground_distance = 10}
      },
      production_type = "output",
      filter = "steam"
    },
    energy_consumption = "1.8MW",
    energy_source =
    {
      type = "burner",
      fuel_category = "chemical",
      effectivity = 1,
      fuel_inventory_size = 1,
      emissions_per_minute = 30,
      smoke =
      {
        {
          name = "smoke",
          north_position = util.by_pixel(-38, -47.5),
          south_position = util.by_pixel(38.5, -32),
          east_position = util.by_pixel(20, -70),
          west_position = util.by_pixel(-19, -8.5),
          frequency = 15,
          starting_vertical_speed = 0.0,
          starting_frame_deviation = 60
        }
      }
    },
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/boiler.ogg",
        volume = 0.8
      },
      max_sounds_per_type = 3
    },

    structure =
    {
      north =
      {
        layers =
        {
          {
            filename = "__base__/graphics/entity/boiler/boiler-N-idle.png",
            priority = "extra-high",
            width = 131,
            height = 108,
            shift = util.by_pixel(-0.5, 4),
            hr_version =
        {
              filename = "__base__/graphics/entity/boiler/hr-boiler-N-idle.png",
              priority = "extra-high",
              width = 269,
              height = 221,
              shift = util.by_pixel(-1.25, 5.25),
              scale = 0.5
            }
          },
          {
            filename = "__base__/graphics/entity/boiler/boiler-N-shadow.png",
            priority = "extra-high",
            width = 137,
            height = 82,
            shift = util.by_pixel(20.5, 9),
            draw_as_shadow = true,
            hr_version =
        {
              filename = "__base__/graphics/entity/boiler/hr-boiler-N-shadow.png",
              priority = "extra-high",
              width = 274,
              height = 164,
              scale = 0.5,
              shift = util.by_pixel(20.5, 9),
              draw_as_shadow = true
            }
          }
        }
      },
      east =
      {
        layers =
        {
          {
            filename = "__base__/graphics/entity/boiler/boiler-E-idle.png",
            priority = "extra-high",
            width = 105,
            height = 147,
            shift = util.by_pixel(-3.5, -0.5),
            hr_version =
        {
              filename = "__base__/graphics/entity/boiler/hr-boiler-E-idle.png",
              priority = "extra-high",
              width = 216,
              height = 301,
              shift = util.by_pixel(-3, 1.25),
              scale = 0.5
            }
          },
          {
            filename = "__base__/graphics/entity/boiler/boiler-E-shadow.png",
            priority = "extra-high",
            width = 92,
            height = 97,
            shift = util.by_pixel(30, 9.5),
            draw_as_shadow = true,
            hr_version =
        {
              filename = "__base__/graphics/entity/boiler/hr-boiler-E-shadow.png",
              priority = "extra-high",
              width = 184,
              height = 194,
              scale = 0.5,
              shift = util.by_pixel(30, 9.5),
              draw_as_shadow = true
            }
          }
        }
      },
      south =
      {
        layers =
        {
          {
            filename = "__base__/graphics/entity/boiler/boiler-S-idle.png",
            priority = "extra-high",
            width = 128,
            height = 95,
            shift = util.by_pixel(3, 12.5),
            hr_version =
        {
              filename = "__base__/graphics/entity/boiler/hr-boiler-S-idle.png",
              priority = "extra-high",
              width = 260,
              height = 192,
              shift = util.by_pixel(4, 13),
              scale = 0.5
            }
          },
          {
            filename = "__base__/graphics/entity/boiler/boiler-S-shadow.png",
            priority = "extra-high",
            width = 156,
            height = 66,
            shift = util.by_pixel(30, 16),
            draw_as_shadow = true,
            hr_version =
        {
              filename = "__base__/graphics/entity/boiler/hr-boiler-S-shadow.png",
              priority = "extra-high",
              width = 311,
              height = 131,
              scale = 0.5,
              shift = util.by_pixel(29.75, 15.75),
              draw_as_shadow = true
            }
          }
        }
      },
      west =
      {
        layers =
        {
          {
            filename = "__base__/graphics/entity/boiler/boiler-W-idle.png",
            priority = "extra-high",
            width = 96,
            height = 132,
            shift = util.by_pixel(1, 5),
            hr_version =
        {
              filename = "__base__/graphics/entity/boiler/hr-boiler-W-idle.png",
              priority = "extra-high",
              width = 196,
              height = 273,
              shift = util.by_pixel(1.5, 7.75),
              scale = 0.5
            }
          },
          {
            filename = "__base__/graphics/entity/boiler/boiler-W-shadow.png",
            priority = "extra-high",
            width = 103,
            height = 109,
            shift = util.by_pixel(19.5, 6.5),
            draw_as_shadow = true,
            hr_version =
        {
              filename = "__base__/graphics/entity/boiler/hr-boiler-W-shadow.png",
              priority = "extra-high",
              width = 206,
              height = 218,
              scale = 0.5,
              shift = util.by_pixel(19.5, 6.5),
              draw_as_shadow = true
            }
          }
        }
      }
    },

    patch =
    {
      east =
      {
        filename = "__base__/graphics/entity/boiler/boiler-E-patch.png",
        priority = "extra-high",
        width = 3,
        height = 17,
        shift = util.by_pixel(33.5, -13.5),
        hr_version =
        {
          filename = "__base__/graphics/entity/boiler/hr-boiler-E-patch.png",
          width = 6,
          height = 36,
          shift = util.by_pixel(33.5, -13.5),
          scale = 0.5
        }
      }
    },

    fire_flicker_enabled = true,
    fire =
    {
      north =
      {
        filename = "__base__/graphics/entity/boiler/boiler-N-fire.png",
        priority = "extra-high",
        frame_count = 64,
        line_length = 8,
        width = 12,
        height = 13,
        animation_speed = 0.5,
        shift = util.by_pixel(0, -8.5),
        hr_version =
        {
          filename = "__base__/graphics/entity/boiler/hr-boiler-N-fire.png",
          priority = "extra-high",
          frame_count = 64,
          line_length = 8,
          width = 26,
          height = 26,
          animation_speed = 0.5,
          shift = util.by_pixel(0, -8.5),
          scale = 0.5
        }
      },
      east =
      {
        filename = "__base__/graphics/entity/boiler/boiler-E-fire.png",
        priority = "extra-high",
        frame_count = 64,
        line_length = 8,
        width = 14,
        height = 14,
        animation_speed = 0.5,
        shift = util.by_pixel(-10, -22),
        hr_version =
        {
          filename = "__base__/graphics/entity/boiler/hr-boiler-E-fire.png",
          priority = "extra-high",
          frame_count = 64,
          line_length = 8,
          width = 28,
          height = 28,
          animation_speed = 0.5,
          shift = util.by_pixel(-9.5, -22),
          scale = 0.5
        }
      },
      south =
      {
        filename = "__base__/graphics/entity/boiler/boiler-S-fire.png",
        priority = "extra-high",
        frame_count = 64,
        line_length = 8,
        width = 12,
        height = 9,
        animation_speed = 0.5,
        shift = util.by_pixel(-1, -26.5),
        hr_version =
        {
          filename = "__base__/graphics/entity/boiler/hr-boiler-S-fire.png",
          priority = "extra-high",
          frame_count = 64,
          line_length = 8,
          width = 26,
          height = 16,
          animation_speed = 0.5,
          shift = util.by_pixel(-1, -26.5),
          scale = 0.5
        }
      },
      west =
      {
        filename = "__base__/graphics/entity/boiler/boiler-W-fire.png",
        priority = "extra-high",
        frame_count = 64,
        line_length = 8,
        width = 14,
        height = 14,
        animation_speed = 0.5,
        shift = util.by_pixel(13, -23),
        hr_version =
        {
          filename = "__base__/graphics/entity/boiler/hr-boiler-W-fire.png",
          priority = "extra-high",
          frame_count = 64,
          line_length = 8,
          width = 30,
          height = 29,
          animation_speed = 0.5,
          shift = util.by_pixel(13, -23.25),
          scale = 0.5
        }
      }
    },

    fire_glow_flicker_enabled = true,

    fire_glow =
    {
      north =
      {
        filename = "__base__/graphics/entity/boiler/boiler-N-light.png",
        priority = "extra-high",
        frame_count = 1,
        width = 100,
        height = 87,
        shift = util.by_pixel(-1, -6.5),
        blend_mode = "additive",
        hr_version =
        {
          filename = "__base__/graphics/entity/boiler/hr-boiler-N-light.png",
          priority = "extra-high",
          frame_count = 1,
          width = 200,
          height = 173,
          shift = util.by_pixel(-1, -6.75),
          blend_mode = "additive",
          scale = 0.5
        }
      },
      east =
      {
        filename = "__base__/graphics/entity/boiler/boiler-E-light.png",
        priority = "extra-high",
        frame_count = 1,
        width = 70,
        height = 122,
        shift = util.by_pixel(0, -13),
        blend_mode = "additive",
        hr_version =
        {
          filename = "__base__/graphics/entity/boiler/hr-boiler-E-light.png",
          priority = "extra-high",
          frame_count = 1,
          width = 139,
          height = 244,
          shift = util.by_pixel(0.25, -13),
          blend_mode = "additive",
          scale = 0.5
        }
      },
      south =
      {
        filename = "__base__/graphics/entity/boiler/boiler-S-light.png",
        priority = "extra-high",
        frame_count = 1,
        width = 100,
        height = 81,
        shift = util.by_pixel(1, 5.5),
        blend_mode = "additive",
        hr_version =
        {
          filename = "__base__/graphics/entity/boiler/hr-boiler-S-light.png",
          priority = "extra-high",
          frame_count = 1,
          width = 200,
          height = 162,
          shift = util.by_pixel(1, 5.5),
          blend_mode = "additive",
          scale = 0.5
        }
      },
      west =
      {
        filename = "__base__/graphics/entity/boiler/boiler-W-light.png",
        priority = "extra-high",
        frame_count = 1,
        width = 68,
        height = 109,
        shift = util.by_pixel(2, -6.5),
        blend_mode = "additive",
        hr_version =
        {
          filename = "__base__/graphics/entity/boiler/hr-boiler-W-light.png",
          priority = "extra-high",
          frame_count = 1,
          width = 136,
          height = 217,
          shift = util.by_pixel(2, -6.25),
          blend_mode = "additive",
          scale = 0.5
        }
      }
    },
    burning_cooldown = 20
  }
})
